#lang racket
(require ffi/unsafe
         ffi/unsafe/define)

(provide (all-defined-out))
 
(define-ffi-definer define-curses (ffi-lib "libncurses"))

(define _WINDOW-pointer (_cpointer 'WINDOW))
 
(define-curses initscr (_fun -> _WINDOW-pointer))
(define-curses endwin (_fun -> _int))

(define-curses waddstr (_fun _WINDOW-pointer _string -> _int))

(define-curses wrefresh (_fun _WINDOW-pointer -> _int))
(define-curses getcurx (_fun _WINDOW-pointer -> _int))
(define-curses getcury (_fun _WINDOW-pointer -> _int))
(define-curses wmove (_fun _WINDOW-pointer _int _int -> _int))

(define-curses noecho (_fun -> _int))
(define-curses cbreak (_fun -> _int))
(define-curses wgetch (_fun _WINDOW-pointer -> _int))

(define _mmask_t _ulong)
(define-curses mousemask (_fun _mmask_t _pointer -> _mmask_t))
(define-curses keypad (_fun _WINDOW-pointer _bool -> _int))
(define BUTTON1_CLICKED 4)

(define KEY_MOUSE #o631)
(define KEY_MAX   #o777)
(define KEY_DOWN  #o402)
(define KEY_UP    #o403)
(define KEY_LEFT  #o404)
(define KEY_RIGHT #o405)

(define-cstruct _MEVENT ([id _short]
                         [x _int]
                         [y _int]
                         [z _int]
                         [bstate _mmask_t]))
(define-curses getmouse (_fun _MEVENT-pointer -> _int))
 
(define (check-error v)
  (unless (zero? v)
    (endwin)
    (error "There was an error")))

